Hooks:PostHook(WeaponFactoryTweakData, "init", "wttd_oapinit_internals", function(self)
	
	-- TODO: Convert pickup multipliers to use WeaponLib overrides.
	
	--[[ Notes on pickup:
		- 40-odd dmg pistols typically have pickup values of 1.5-5.4
		- 60-odd dmg pistols typically have pickup values of 0.9-3.1
		- 120-odd dmg pistols typically have pickup values of 0.6-2.1
		- Revolvers typically have pickup values of 0.5-1.8
		
		- 40-odd dmg rifles/smgs typically have pickup values of 7-13
		- 60-odd dmg rifles/smgs typically have pickup values of 4.5-8.25
		- 100-odd dmg rifles/smgs typically have pickup values of 1-3.5
		- DMR-class rifles typically have pickup values of 0.35-1.05
		- Given the above I'd expect 80-odd dmg rifles to have a pickup value of 3.2-6.7, maybe 2.9-6.45 if i'm feeling like a bit of a dick :^)
		- As for 120-odd non-jules-DMR rifles i'd probably put them at around 0.75-3
		
		- Double-barrels, the 1887, and the Ithaca typically have pickup values of 0.25-0.95
		- Primary autoshotties typically have pickup values of 3.5-5.25
		- Pump shotguns typically have pickup values of 0.42-1.47
		- The Spike-12 has pickup values 5.2-7.8
		- The Six12 has pickup values 2.7-4.05
		- The DAO-12 has pickup values 3.6-5.4
		- The Judge has pickup values 0.175-0.525, no wonder it's so doodoo lul
		
		- Semiautomatic snipers and the MSR/Winchester seem to have pickup values 2-3
		- 500-odd dmg snipers have pickup values 0.7-1, for some reason i guess
		- The M95 and all grenade launchers have pickup values 0.05-0.65
		- ...except for the underbarrel M203, which has pickup 0.2-0.7 for SOME reason
	
	]]

	if self.parts.wpn_fps_upg_pull_straight then -- Greased/straight bolt courtesy of SQP. One of the few true holdovers from OAP1.
		self.parts.wpn_fps_upg_pull_straight.has_description = true
		self.parts.wpn_fps_upg_pull_straight.custom_stats = {
			rays = 1, -- unnecessary???????
			rof_mult = 1.25,
			anim_speed_mult = 1,
			ads_anim_speed_mult = 1.25,
			hipfire_anim_speed_mult = 1.25
		}
	end
	self.parts.wpn_fps_upg_am_kluge.custom_stats = { -- Internal bit used for the MP5/10 and UMP-40 kits.
		rays = 1,
		armor_piercing_add = 1,
		can_shoot_through_enemy = true,
		can_shoot_through_shield = true, 
		can_shoot_through_wall = true
	}
	self.parts.wpn_fps_upg_am_rjhp.custom_stats = { -- Remington RJHPs for 40-odd dmg pistols.
	--	ammo_pickup_min_mul = 0.6, -- 0.9/1.5
	--	ammo_pickup_max_mul = 0.574 -- 3.1/5.4
	}
	self.parts.wpn_fps_upg_am_rjhp.override_weapon_multiply = { -- Remington RJHPs for 40-odd dmg pistols.
		AMMO_PICKUP={0.6, 0.574}
	}
	self.parts.wpn_fps_upg_mp5_m_ten.has_description = true
	self.parts.wpn_fps_upg_mp5_m_ten.custom_stats = { -- MP5/10 Conversion kit.
		rays = 1,
		--ammo_pickup_min_mul = 0.4571, -- 3.2/7
		--ammo_pickup_max_mul = 0.5153, -- 6.7/13
		armor_piercing_add = 1, -- none of these do anything apparently, but who shits a fuck
		can_shoot_through_enemy = true,
		can_shoot_through_shield = true, 
		can_shoot_through_wall = true
	}
	self.parts.wpn_fps_upg_mp5_m_ten.override_weapon_multiply = {
		AMMO_PICKUP={0.4571,0.5153}
	}
	self.parts.wpn_fps_upg_schakal_m_atai.has_description = true
	self.parts.wpn_fps_upg_schakal_m_atai.custom_stats = { -- UMP-40 conversion kit.
		rays = 1,
		--ammo_pickup_min_mul = 3.2, -- 3.2/1
		--ammo_pickup_max_mul = 1.914, -- 6.7/3.5
		armor_piercing_add = 1,
		can_shoot_through_enemy = true,
		can_shoot_through_shield = true, 
		can_shoot_through_wall = true
	}
	self.parts.wpn_fps_upg_schakal_m_atai.override_weapon_multiply = {
		AMMO_PICKUP={3.2, 1.914}
	}
	self.parts.wpn_fps_upg_schakal_m_nine.has_description = true
	self.parts.wpn_fps_upg_schakal_m_nine.custom_stats = {
		rays = 1,
		--ammo_pickup_min_mul = 7, -- 7/1
		--ammo_pickup_max_mul = 3.7, -- 13/3.5
		armor_piercing_add = 0,
		can_shoot_through_enemy = false,
		can_shoot_through_shield = false, 
		can_shoot_through_wall = false
	}
	self.parts.wpn_fps_upg_schakal_m_nine.override_weapon_multiply = {
		AMMO_PICKUP={7, 3.7}
	}
	
	self.parts.wpn_fps_upg_am_snap.has_description = true -- do i even NEED to do all this dog
	self.parts.wpn_fps_upg_am_slap.has_description = true
	self.parts.wpn_fps_upg_am_plusp.has_description = true
	self.parts.wpn_fps_upg_sub2000_m_short.has_description = true
	self.parts.wpn_fps_upg_ching_am_crap.has_description = true
	self.parts.wpn_fps_upg_tecci_am_beefy.has_description = true
	self.parts.wpn_fps_upg_am_lame.has_description = true
	self.parts.wpn_fps_upg_tr_match.has_description = true
	
	self.parts.wpn_fps_upg_am_lame.custom_stats = { -- match-grade rounds (reclass 100-odd into 60-odd)
			rays = 1,
			--ammo_pickup_min_mul = 4.5, -- 4.5/1
			--ammo_pickup_max_mul = 2.3571, -- 8.25/3.5
			armor_piercing_add = 0,
			can_shoot_through_enemy = false, 
			can_shoot_through_shield = false, 
			can_shoot_through_wall = false
		}
	self.parts.wpn_fps_upg_am_lame.override_weapon_multiply = {
		AMMO_PICKUP={4.5, 2.3751}
	}
	self.parts.wpn_fps_upg_am_plusp.custom_stats = { -- +p+ rounds (reclass 100-odd into 120-odd)
			rays = 1,
			--ammo_pickup_min_mul = 0.95, -- fuck it, this works
			--ammo_pickup_max_mul = 0.95,
			armor_piercing_add = 1,
			can_shoot_through_enemy = true, 
			can_shoot_through_shield = true, 
			can_shoot_through_wall = true
		}
	self.parts.wpn_fps_upg_am_lame.override_weapon_multiply = {
		AMMO_PICKUP={0.95, 0.95}
	}
	self.parts.wpn_fps_upg_am_slap.custom_stats = { -- sabot, light armor piercing (smol boost for 60-odd rifles because fuck using the fire breather on everything
			rays = 1,
			--ammo_pickup_min_mul = 0.9,
			--ammo_pickup_max_mul = 0.9, -- fuck it, this works
			armor_piercing_add = 1,
			can_shoot_through_enemy = false, 
			can_shoot_through_shield = false, 
			can_shoot_through_wall = true
		}
	self.parts.wpn_fps_upg_am_slap.override_weapon_multiply = {
		AMMO_PICKUP={0.9, 0.9}
	}
	self.parts.wpn_fps_upg_am_snap.custom_stats = { -- sabot, no armor piercing (reclass 40-odd into 60-odd)
			rays = 1,
			--ammo_pickup_min_mul = 0.642, -- 4.5/7
			--ammo_pickup_max_mul = 0.634, -- 8.25/13
			armor_piercing_add = 0,
			can_shoot_through_enemy = false, 
			can_shoot_through_shield = false, 
			can_shoot_through_wall = false
		}
	self.parts.wpn_fps_upg_am_snap.override_weapon_multiply = {
		AMMO_PICKUP={0.642, 0.634}
	}
	self.parts.wpn_fps_upg_m14_am_m993.custom_stats = { -- M993 armor-piercing (reclasses M14 into 120-odd)
			rays = 1,
			--ammo_pickup_min_mul = 2.142, -- 0.75/0.35
			--ammo_pickup_max_mul = 2.857, -- 3/1.05
			armor_piercing_add = 1,
			can_shoot_through_enemy = true, 
			can_shoot_through_shield = true, 
			can_shoot_through_wall = true
		}
	self.parts.wpn_fps_upg_m14_am_m993.override_weapon_multiply = {
		AMMO_PICKUP={2.142, 2.857}
	}
	self.parts.wpn_fps_upg_ching_am_crap.custom_stats = { -- The shittiest .30-06 rounds youve ever seen (reclasses garand into 120-odd)
			rays = 1,
			--ammo_pickup_min_mul = 2.142, -- 0.75/0.35
			--ammo_pickup_max_mul = 2.857, -- 3/1.05
			armor_piercing_add = 0,
			can_shoot_through_enemy = false, 
			can_shoot_through_shield = false, 
			can_shoot_through_wall = false
		}
	self.parts.wpn_fps_upg_ching_am_crap.override_weapon_multiply = {
		AMMO_PICKUP={2.142, 2.857}
	}
	self.parts.wpn_fps_upg_tecci_am_beefy.custom_stats = { -- Tactical blue hollow-points (reclasses 416c into 60-odd)
			rays = 1,
			--ammo_pickup_min_mul = 0.72, -- these are a little above normal SNAP rounds because iirc the 416c has noticably bad pickup for its class
			--ammo_pickup_max_mul = 0.72, -- THXJULES
			armor_piercing_add = 0,
			can_shoot_through_enemy = false, 
			can_shoot_through_shield = false, 
			can_shoot_through_wall = false
		}
	self.parts.wpn_fps_upg_tecci_am_beefy.override_weapon_multiply = {
		AMMO_PICKUP={0.72, 0.72}
	}
	self.parts.wpn_fps_upg_sub2000_m_short.custom_stats = { -- Smol magazine (reclasses SUB2000 into 120-odd)
			rays = 1,
			--ammo_pickup_min_mul = 2.142, -- 0.75/0.35
			--ammo_pickup_max_mul = 2.857, -- 3/1.05
			armor_piercing_add = 0,
			can_shoot_through_enemy = false, 
			can_shoot_through_shield = false, 
			can_shoot_through_wall = false
		}
	self.parts.wpn_fps_upg_sub2000_m_short.override_weapon_multiply = {
		AMMO_PICKUP={2.142, 2.857}
	}
	self.parts.wpn_fps_upg_komodo_am_iwirazor.custom_stats = { -- IWI Razor-Core (unique alternate version of the SLAP rounds)
			rays = 1,
			--ammo_pickup_min_mul = 0.9, -- 
			--ammo_pickup_max_mul = 0.9, -- 
			armor_piercing_add = 0,
			can_shoot_through_enemy = false, 
			can_shoot_through_shield = false, 
			can_shoot_through_wall = false
		}
	self.parts.wpn_fps_upg_komodo_am_iwirazor.override_weapon_multiply = {
		AMMO_PICKUP={0.9, 0.9}
	}
	self.parts.wpn_fps_upg_m95_am_steyr.override_weapon_multiply = {
		AMMO_PICKUP={14, 1.615}
		}
	self.parts.wpn_fps_upg_12g_am_rip.custom_stats = { -- Hollow-point 12G slugs (holy shit they deal so much damage but pickup for these things SUCKS)
			rays = 1,
			--ammo_pickup_min_mul = 0.8, -- 
			--ammo_pickup_max_mul = 0.8, -- 
			armor_piercing_add = 0,
			can_shoot_through_enemy = false, 
			can_shoot_through_shield = false, 
			can_shoot_through_wall = false
		}
	self.parts.wpn_fps_upg_12g_am_rip.override_weapon_multiply = {
		AMMO_PICKUP={0.8, 0.8}
	}
	self.parts.wpn_fps_upg_siltstone_am_lancaster.custom_stats = { -- 9x53 LANCASTER for the SVD (no pickup change would be more accurate to vanilla but gfy jules)
			rays = 1,
			--ammo_pickup_min_mul = 0.7, -- you now have a small chance to only get one boolet
			--ammo_pickup_max_mul = 0.9, -- you now have a lesser chance to get whole three boolet
			armor_piercing_add = 1,
			can_shoot_through_enemy = true, 
			can_shoot_through_shield = true, 
			can_shoot_through_wall = true
		}
	self.parts.wpn_fps_upg_siltstone_am_lancaster.override_weapon_multiply = {
		AMMO_PICKUP={0.7, 0.9},
			stats = {
				damage = 2
			}
		}
	self.parts.wpn_fps_upg_g17_am_gap.custom_stats = { -- .45 GAP (converts glocc from 40-odd into 120-odd)
			rays = 1,
			--ammo_pickup_min_mul = 0.4, -- 0.6/1.5
			--ammo_pickup_max_mul = 0.3888, -- 2.1/5.4
			armor_piercing_add = 0,
			can_shoot_through_enemy = false, 
			can_shoot_through_shield = false, 
			can_shoot_through_wall = false
		}
	self.parts.wpn_fps_upg_g17_am_gap.override_weapon_multiply = {
		AMMO_PICKUP={0.4, 0.3888}
	}
		-- todo figure out if i want to keep the idea of 40mm ammo types and .366 tkm for the AKs and if i do then code them
	
		-- weeponlip time
	if self.parts.wpn_fps_upg_tr_match then -- Match trigger, RoF buff for semi-auto weapons.
		self.parts.wpn_fps_upg_tr_match.override_weapon_multiply = {
			fire_mode_data = {
				fire_rate = 1 / 1.5 -- down from 1 / 2.8
			}
		}
	end
	
	if self.parts.wpn_fps_upg_tr_light then -- Light trigger, RoF buff/stab nerf for auto weapons.
		self.parts.wpn_fps_upg_tr_light.has_description = true
		self.parts.wpn_fps_upg_tr_light.override_weapon_multiply = {
			fire_mode_data = {
				fire_rate = 1 / 1.15
			}
		}
	end
	
	if self.parts.wpn_fps_upg_tr_heavy then -- Heavy trigger, stab buff/RoF nerf for auto weapons.
		self.parts.wpn_fps_upg_tr_heavy.has_description = true
		self.parts.wpn_fps_upg_tr_heavy.override_weapon_multiply = {
			fire_mode_data = {
				fire_rate = 1 / 0.85
			}
		}
	end
	
	-- CUSTOM WEAPON TIME BOTTOM TEXT
	
	local function do_part_insert_thingy(weapon_table,part_id)
		for _, wep_id in pairs(weapon_table) do
			if self[wep_id] then
				table.insert(self[wep_id].uses_parts, part_id) -- tfw stealing code from hdd lambda now
			end
		end
	end
	
	local manually_add_triggers_to = { -- polmao
		"wpn_fps_ass_mk18s",
		"wpn_fps_ass_gcar",
		"wpn_fps_lmg_rpk"
	}
	do_part_insert_thingy(manually_add_triggers_to,"wpn_fps_upg_tr_heavy")
	do_part_insert_thingy(manually_add_triggers_to,"wpn_fps_upg_tr_light")
	
	local customs_snap = {
		"wpn_fps_smg_minebea",
		"wpn_fps_smg_ppsh",
		"wpn_fps_ass_temple",
		"wpn_fps_smg_aug9mm",
		"wpn_fps_smg_k1a7",
		"wpn_fps_mp_master",
		"wpn_fps_smg_car9",
		"wpn_fps_smg_x_car9"
	}
	do_part_insert_thingy(customs_snap,"wpn_fps_upg_am_snap")
	
	local customs_slap = {
		"wpn_fps_ass_hk416",
		"wpn_fps_smg_czevo",
		"wpn_fps_ass_howl",
		"wpn_fps_smg_aek919",
		"wpn_fps_ass_ak12",
		"wpn_fps_ass_aek971",
		"wpn_fps_smg_fmg9",
		"wpn_fps_ass_mk18s",
		"wpn_fps_ass_lazy",
		"wpn_fps_ass_bajur",
		"wpn_fps_ass_gcar"
	}
	do_part_insert_thingy(customs_slap,"wpn_fps_upg_am_slap")
	
	local customs_namegoeshere = {
		"wpn_fps_smg_ro933blk",
		"wpn_fps_ass_recce",
		"wpn_fps_ass_bulldoge",
		"wpn_fps_pis_m45a1",
		"wpn_fps_ass_sar21",
		"wpn_fps_ass_adar",
		"wpn_fps_ass_vsk94"
	}
	do_part_insert_thingy(customs_namegoeshere,"wpn_fps_upg_am_lame")
	do_part_insert_thingy(customs_namegoeshere,"wpn_fps_upg_am_plusp")
	
	local customs_rjhp = {
		"wpn_fps_pis_seburo",
		"wpn_fps_pis_k5",
		"wpn_fps_pis_gsh18",
		"wpn_fps_mp_peepee"
	}
	do_part_insert_thingy(customs_rjhp,"wpn_fps_upg_am_rjhp")
	
	local customs_match = {
		"wpn_fps_snp_sr25",
		"wpn_fps_snp_mk12",
		"wpn_fps_snp_fd338",
		"wpn_fps_ass_obr5"
	}
	do_part_insert_thingy(customs_match,"wpn_fps_upg_tr_match")
	
	local customs_steyr = {
		"wpn_fps_snp_m107cq",
		"wpn_fps_snp_hecate"
	}
	do_part_insert_thingy(customs_steyr,"wpn_fps_upg_m95_am_steyr")
	
	local customs_straight = {
		"wpn_fps_snp_m200",
		"wpn_fps_snp_cs5",
		"wpn_fps_snp_b42",
		"wpn_fps_snp_t1000x5",
		"wpn_fps_snp_heartpiercer",
		"wpn_fps_snp_troglodyte",
		"wpn_fps_snp_l115",
		"wpn_fps_snp_m98b"
	}
	do_part_insert_thingy(customs_straight,"wpn_fps_upg_pull_straight")
	
	local shomtguns = {
        "wpn_fps_shot_saiga",
		"wpn_fps_sho_basset",
		"wpn_fps_shot_basset", -- WHICH FUCKING ONE OF THESE IS IT AAAAAAAAAA
		"wpn_fps_sho_ben",
		"wpn_fps_sho_spas12",
		"wpn_fps_sho_aa12",
		"wpn_fps_sho_rota",
		"wpn_fps_sho_striker",
		"wpn_fps_sho_usas12",
		"wpn_fps_shot_vepr12",
		"wpn_fps_shot_ak12_76",
		"wpn_fps_shot_m1216",
		"wpn_fps_shot_spas15",
		"wpn_fps_shot_prison",
		"wpn_fps_shot_amr12",
		"wpn_fps_shot_wmtx",
		"wpn_fps_shot_techno",
		"wpn_fps_shot_qbs",
		"wpn_fps_shot_auto5",
		"wpn_fps_sho_maul",
		"wpn_fps_shot_minibeck",
		"wpn_fps_shot_jackhammer",
		"wpn_fps_shot_r870",
		"wpn_fps_sho_ksg",
		"wpn_fps_shot_huntsman",
		"wpn_fps_sho_boot",
		"wpn_fps_shot_b682",
		"wpn_fps_shot_m1897",
		"wpn_fps_shot_serbu",
		"wpn_fps_sho_coach",
		"wpn_fps_shot_m37",
		"wpn_fps_pis_judge",
		"wpn_fps_sho_heffy_12g",
		"wpn_fps_shot_pa8",
		"wpn_fps_shot_stf12",
		"wpn_fps_shot_toz106",
		"wpn_fps_shot_toz34",
		"wpn_fps_shot_m590",
		"wpn_fps_shot_toz194",
		"wpn_fps_shot_mp153",
		"wpn_fps_shot_trench",
		"wpn_fps_sho_dp12",
		"wpn_fps_shot_sjogren",
		"wpn_fps_shot_r870sawed",
		"wpn_fps_shot_fpsix",
		"wpn_fps_shot_m1912",
		"wpn_fps_shot_triple",
		"wpn_fps_shot_quadbarrel",
		"wpn_fps_shot_sideload",
		"wpn_fps_sho_littlest",
		"wpn_fps_shot_mts255",
		"wpn_fps_shot_dokkasho",
		"wpn_fps_shot_beck",
		"wpn_fps_shot_hawk12",
		"wpn_fps_shot_f500",
		"wpn_fps_shot_toz66",
		"wpn_fps_shot_novas",
		"wpn_fps_sho_ashot"
	}
	do_part_insert_thingy(shomtguns,"wpn_fps_upg_12g_am_rip")

end)